<script>
const TYPE_DIALOG_SIGNALER="SIGNALER";
const TYPE_DIALOG_MAIL_ENVOYER="MAIL_ENVOYER";
const CLASS_PANNEAU=" absolute top-0 left-0 p-4 bg-white rounded-[10px] shadow-las ";

const classVisibleDialog=ref(" invisible ");
const typeDialog=ref("");
const dataSignaler=ref (null);

// export function
export async function  showDialogSignalerEvent (data) {
    dataSignaler.value=data;
    showDialog (TYPE_DIALOG_SIGNALER);
}

async function showDialog (type){
    classVisibleDialog.value=" visible ";
    typeDialog.value=type;

    window.scrollTo({top: 0, behavior: 'smooth'});
}

export async function hideDialog () {
    classVisibleDialog.value=" invisible "
    typeDialog.value=null;
}
</script>
<script setup >

const mode=computed (()=>{
    return typeDialog.value;    
});

const isVisible= computed (()=> {
    return classVisibleDialog.value;
});

const dataSignalerEvent = computed (()=>{
    return dataSignaler.value;
});

const hauteurDialog = computed (()=>{
    if (typeDialog.value==TYPE_DIALOG_SIGNALER){
        return "600";
    }else if (typeDialog.value==TYPE_DIALOG_MAIL_ENVOYER){
        return "175";
    }

    return "0";
});

function emailPost () {
    typeDialog.value=TYPE_DIALOG_MAIL_ENVOYER;
}
</script>

<template>
    <div :class="'w-full h-[2200px] absolute top-0 left-0 flex justify-center bg-slate-100 opacity-90 z-99'+isVisible" >

    </div>

    <div :class="'w-full h-[2200px] absolute top-0 left-0 flex justify-center z-100'+isVisible">
     <div :class="'md:w-[600px] sm:w-[400px] min-w-[300px] h-['+hauteurDialog+'px] absolute top-[100px] bg-white shadow-las rounded-2xl'">
                <!-- divers panneau de la dialog -->
            <dialogSignaler :data="dataSignalerEvent" @email_post="emailPost" :class="' h-['+hauteurDialog+'px] '+CLASS_PANNEAU+(mode==TYPE_DIALOG_SIGNALER?'visible':'invisible')" />
            <dialogMessage message="Merci, ton signalement a bien été pris en compte !" :class="' pt-6 pr-16 md:pr-60 h-['+hauteurDialog+'px] '+CLASS_PANNEAU+(mode==TYPE_DIALOG_MAIL_ENVOYER?'visible':'invisible')" />

                <!-- bouton fermer -->
            <img src="/images/cross.svg" class=" absolute top-0 right-0 m-2 hover:cursor-pointer" width="16px" height="16px"  alt="fermer la boite de dialogue" @click="hideDialog ()" />
        </div>
    </div>

</template>